#define INCL_DOSNMPIPES
#define INCL_DOSMODULEMGR
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <string.h>
#include "process.h"
#include "communication.h"
#include "calcFractal.h"
#include "string.h"


class serverProcess;


class serverThread:public thread
{       public:
	serverProcess *pProcess;
	pFctCalculateFractal pFctCalculate;
	HPIPE hPipe;
	serverThread(serverProcess *pProcessNew);
	//virtual ~serverThread(void)
	virtual Boolean create(void);
	Boolean calculate(structRequest *pStructR);
	virtual void doSomething(void);
	virtual void destruct(void);
};


class serverMainThread:public thread
{	public:
	serverProcess *pProcess;
	serverMainThread(serverProcess *pProcess);
	virtual void doSomething(void);
};


class serverProcess:public process
{	public:
	char *pPipeName;
	chain chainDLLNames;
	serverProcess(int argc, char **argv);
	virtual Boolean create(void);
};


#define idForeachDLLNameGetThisByDescription (idForeachStringChainElementLast + 1)
class dLLName:public stringChainElement
{	public:
	pFctCalculateFractal pFctCalculate;
	char *pDescription;
	//unsigned int iId;
	HMODULE hDLL;
	dLLName(char *pString, chain *pParent);
	virtual ~dLLName(void);
	virtual int toBeCalledForeachElement(unsigned int iMsg, void *pDummy);
};

